/*************************************************
* ISAAC Header File                              *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_ISAAC_H__
#define OPENCL_ISAAC_H__

#include "opencl.h"

namespace OpenCL {

class ISAAC : public StreamCipher
   {
   public:
      static const u32bit KEYLENGTH = 32;
      void encrypt(const byte[], byte[], u32bit);
      void encrypt(byte in[], u32bit len) { encrypt(in, in, len); }
      void set_key(const byte[], u32bit = KEYLENGTH) throw(InvalidKeyLength);
      void clear() throw();
      ISAAC()  { clear(); }
      ~ISAAC() { clear(); }
   private:
      static const u32bit STATESIZE = DEFAULT_BUFFERSIZE;
      void generate();
      SecureBuffer<u32bit, 256> state;
      SecureBuffer<byte, STATESIZE> buffer;
      u32bit A, B, C, position;
   };

}

#endif
