/*************************************************
* SymmetricKey Header File                       *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_SYMKEY_H__
#define OPENCL_SYMKEY_H__

#include "opencl.h"

namespace OpenCL {

/*************************************************
* SymmetricKey                                   *
*************************************************/
class SymmetricKey
   {
   public:
      operator const byte* () const { return key; }
      u32bit length() const { return key.size(); }

      SymmetricKey(RandomNumberGenerator& rng, u32bit len)
         { key.create(len); rng.randomize(key, len); }
      SymmetricKey(const byte in[], u32bit len) { key.copy(in, len); }
   private:
      SecureVector<byte> key;
   };

typedef SymmetricKey BlockCipherKey;
typedef SymmetricKey StreamCipherKey;
typedef SymmetricKey MACKey;

}

#endif
