##################################################
# RPM spec file for OpenCL                       #
##################################################

Name: OpenCL
Summary: A C++ crypto library
Version: $VERSION
Release: 1
Copyright: BSD
Group: Libraries/Cryptography
Source: ftp://ftp.sourceforge.net/pub/opencl/OpenCL-$VERSION.tgz
URL: http://opencl.sourceforge.net
Packager: Jack Lloyd <lloyd@acm.jhu.edu>

BuildRoot: /tmp/OpenCL-$VERSION

Prefix: /usr/local

%description
OpenCL is a C++ cryptography library, designed for high portability and easy of
use. It includes a wide selection of block and stream ciphers, hash functions,
MACs, and various utility classes and functions, plus a high-level filter based
interface.

%package devel
Summary: Development files for OpenCL
Group: Libraries/Cryptography
Requires: OpenCL = $VERSION
%description devel
The OpenCL-devel package contains the header files and libraries needed to
develop programs that use the OpenCL cryptography library.

%prep
%setup -n OpenCL-$VERSION

%build
./configure.pl gcc-%{_target_os}-%{_target_cpu}
make -j 2 shared static 2>/dev/null

%clean
rm -rf $RPM_BUILD_ROOT

%install
ROOT="$RPM_BUILD_ROOT/usr/local"
make OWNER=`id -u` GROUP=`id -g` INSTALLROOT="$ROOT" install

# Need this since we're installing shared libs...
%post
if ! grep "^$RPM_INSTALL_PREFIX/lib$" /etc/ld.so.conf 2>&1 >/dev/null
then
   echo "$RPM_INSTALL_PREFIX/lib" >>/etc/ld.so.conf
fi
/sbin/ldconfig

%post devel
if [ $RPM_INSTALL_PREFIX != "/usr" ]
then
   ln -s $RPM_INSTALL_PREFIX/include/opencl /usr/include/opencl
fi

%postun
/sbin/ldconfig
set +e # some of these rmdirs will probably fail, that's ok
rmdir $RPM_INSTALL_PREFIX/share/doc/OpenCL-$VERSION 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/share/doc 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/lib 2>&1 >/dev/null

%postun devel
if [ $RPM_INSTALL_PREFIX != "/usr" ]
then
   if [ -f /usr/include/opencl ]
   then
      rm -f /usr/include/opencl
   fi
fi
set +e # some of these rmdirs will probably fail, that's ok
rmdir $RPM_INSTALL_PREFIX/share/doc/OpenCL-$VERSION 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/share/doc 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/lib 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/include/opencl 2>&1 >/dev/null
rmdir $RPM_INSTALL_PREFIX/include 2>&1 >/dev/null

%files
%attr(-,root,root) %docdir /usr/local/share/doc/OpenCL-$VERSION/
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/license.txt
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/readme.txt
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/thanks.txt
%attr(-,root,root) /usr/local/lib/libopencl.so
%attr(-,root,root) /usr/local/lib/libopencl-$MAJOR.so
%attr(-,root,root) /usr/local/lib/libopencl-$MAJOR.$MINOR.so
%attr(-,root,root) /usr/local/lib/libopencl-$MAJOR.$MINOR.$PATCH.so

%files devel
%attr(-,root,root) %docdir /usr/local/share/doc/OpenCL-$VERSION/
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/opencl.asc
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/opencl.tex
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/opencl.ps
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/relnotes.txt
%attr(-,root,root) /usr/local/share/doc/OpenCL-$VERSION/todo.txt
%attr(-,root,root) /usr/local/lib/libopencl.a
%attr(-,root,root) /usr/local/include/opencl/

